import time
from PyQt5.QtCore import QObject, QTimer, pyqtSignal


class Clock(QObject):

    year = pyqtSignal(int)
    month = pyqtSignal(int)
    day = pyqtSignal(int)
    hour = pyqtSignal(int)
    min = pyqtSignal(int)
    sec = pyqtSignal(int)

    def __init__(self):
        super().__init__()
        new_time = time.localtime()
        old_time = new_time
        self.localtime = new_time

        def process_time():
            nonlocal old_time
            nonlocal new_time
            new_time = time.localtime()
            self.localtime = new_time
            if new_time.tm_year != old_time.tm_year:
                self.year.emit(new_time.tm_year)
            if new_time.tm_mon != old_time.tm_mon:
                self.month.emit(new_time.tm_mon)
            if new_time.tm_mday != old_time.tm_mday:
                self.day.emit(new_time.tm_mday)
            if new_time.tm_hour != old_time.tm_hour:
                self.hour.emit(new_time.tm_hour)
            if new_time.tm_min != old_time.tm_min:
                self.min.emit(new_time.tm_min)
            if new_time.tm_sec != old_time.tm_sec:
                self.sec.emit(new_time.tm_sec)
            #    tm_wday, tm_yday, tm_isdst
            old_time = new_time

        timer = QTimer(self)
        timer.timeout.connect(process_time)
        timer.start(500)  # half second

    def resend(self):
        self.year.emit(self.localtime.tm_year)
        self.month.emit(self.localtime.tm_mon)
        self.day.emit(self.localtime.tm_mday)
        self.hour.emit(self.localtime.tm_hour)
        self.min.emit(self.localtime.tm_min)
        self.sec.emit(self.localtime.tm_sec)
