from PyQt5.QtWidgets import QLabel, QPushButton

from window_default import WindowDefaultWidget

from users.main import UsersMainWidget
from pref.menu import PrefMenuWidget
from others.info import InfoWidget


class MenuWidget(WindowDefaultWidget):
    def __init__(self, protocol, parent=None):
        super().__init__(parent)

        self.protocol = protocol
        self.main_window = parent
        self.parent = parent

        def make_btn(x, name, text):
            btn = QPushButton(None, self)
            btn.setGeometry(x, 163, 80, 80)
            btn.setObjectName(name)

            lbl = QLabel(text, self)
            lbl.setGeometry(x+40-100, 260, 200, 90)
            lbl.setObjectName('button_label')
            return btn

#        make_btn(119, 'button_users', _("Пользователи")).clicked.connect(
#            UsersMainWidget(self.protocol, self).show)

        make_btn(360, 'button_pref', _("Настройки")).clicked.connect(
            PrefMenuWidget(self.protocol, self.main_window, self).show)

        make_btn(600, 'button_info', _("Информация\nо системе")).clicked.connect(
            InfoWidget(self.protocol, self).show)
