from PyQt5.QtWidgets import QLabel, QPushButton
from PyQt5.QtGui import QPixmap

from window_default import WindowDefaultWidget


class PrefLightWidget(WindowDefaultWidget):
    def __init__(self, brightness, parent=None):
        super().__init__(parent)

        pic = QLabel(self)
        pic.setGeometry(400-40, 73, 80, 80)
        pic.setPixmap(QPixmap("res/light.svg"))

        label = QLabel(_("Яркость экрана"), self)
        label.setGeometry(250, 165, 600-250, 197-165)
        label.setObjectName('light')

        button = QPushButton('<', self)
        button.setGeometry(194, 227, 300-194, 306-227)
        button.setObjectName('left')
        button.clicked.connect(lambda: brightness.change(-1))

        button = QPushButton('>', self)
        button.setGeometry(500, 227, 606-500, 306-227)
        button.setObjectName('right')
        button.clicked.connect(lambda: brightness.change(+1))

        light_info = QLabel(None, self)
        light_info.setGeometry(300, 227, 500-300, 306-227)
        light_info.setObjectName('light_info')
        # self.set_light = light_info.setNum
        # self.light_info = light_info
        light_info.setNum(brightness.light)

        brightness.changed.connect(light_info.setNum)

        save = QPushButton(_("Сохранить"), self)
        save.setGeometry(300, 382, 500-300, 460-382)
        save.setObjectName('save')
        save.clicked.connect(self.accept.emit)
        save.clicked.connect(self.go_back.emit)
