from PyQt5.QtWidgets import QLabel, QPushButton

from window_default import WindowDefaultWidget

from pref.network import PrefNetworkWidget
from pref.date import PrefDateWidget
from pref.set_time import PrefTimeWidget
from pref.light import PrefLightWidget


class PrefMenuWidget(WindowDefaultWidget):
    def __init__(self, protocol, main_window, parent=None):
        super().__init__(parent)

        self.protocol = protocol
        self.main_window = main_window
        self.parent = parent

        def make_btn(x, name, text):
            btn = QPushButton(None, self)
            btn.setGeometry(x, 163, 80, 80)
            btn.setObjectName(name)

            lbl = QLabel(text, self)
            lbl.setGeometry(x+40-100, 260, 200, 90)
            lbl.setObjectName('button_label')
            return btn

        make_btn(67, 'button_net', _("IP-адрес и<br>сетевые<br>настройки"))\
            .clicked.connect(PrefNetworkWidget(self.protocol, self).show)

        make_btn(262, 'button_date', _("Дата"))\
            .clicked.connect(PrefDateWidget(self.protocol, self).show)

        make_btn(457, 'button_time', _("Время")).clicked.connect(
            PrefTimeWidget(self.protocol, self.main_window.clock, self).show)

        page = PrefLightWidget(self.main_window.brightness, self)
        self.prev_light = self.main_window.brightness.light
        page.cancel.connect(
            lambda: self.main_window.brightness.set(self.prev_light))

        def light_save():
            self.prev_light = self.main_window.brightness.light
            self.protocol.setSettings(
                {'licon_light': self.main_window.brightness.light})
        page.accept.connect(light_save)

        make_btn(651, 'button_light', _("Яркость<br>экрана"))\
            .clicked.connect(page.show)
