from PyQt5.QtWidgets import QLabel

from users.user_window_default import UserWindowDefaultWidget


class UsersNewCardWidget(UserWindowDefaultWidget):
    def __init__(self, parent=None):
        super().__init__(parent)

        self.protocol.events.connect(self.eventAnswer)
        self.protocol.answer.connect(self.protocolAnswer)
        # protocol.unlock(False)

        lbl = QLabel('', self)
        lbl.setGeometry(0, 72, 800, 480-72)
        lbl.setObjectName('info')

        self.set_info = lbl.setText

    def show(self):
        self.set_info(_("Предъявите карту считывателю"))
        super().show()

    def protocolAnswer(self, msg):
        if 'answer' not in msg:
            return

        answer = msg['answer']

        if 'uid' in answer:
            if 'set' in answer and answer['set'] == 'own':
                if answer['uid'] == 'ok':
                    self.go_back.emit()
                else:
                    self.set_info(_("Ошибка добавления карты"))

    def eventAnswer(self, msg):
        if self.isHidden():
            return

        if 'code' not in msg:
            return

        if 'id_type' in msg and msg['id_type'] == 'finger':
            self.set_info(_("Предъявите карту"))
            return

        if 'card' not in msg:
            return

        card = msg['card']

        if msg['code'] == 1:
            # self.protocol.unlock('ignore')
            self.protocol.newCard(self.selected_user['account_id'], card)
        elif msg['code'] == 11:
            # self.protocol.unlock('ignore')
            self.set_info(
                _("Карта %s уже зарегистрирована<br>Предъявите другую") % card)
